Public Class Form1

    Friend Declare Auto Function WindowFromPoint Lib "user32" (ByVal x As Int32, ByVal y As Int32) As Int32
    Friend Declare Auto Function GetWindowText Lib "user32.dll" (ByVal hwnd As Int32, ByVal lpString As System.Text.StringBuilder, ByVal cch As Int32) As Int32
    Friend Declare Auto Function GetWindowTextLength Lib "user32.dll" (ByVal hwnd As Int32) As Int32
    Friend Declare Auto Function GetParent Lib "user32.dll" (ByVal hwnd As Int32) As Int32

    Private Sub tmrCheckMouse_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrCheckMouse.Tick
        Dim txt As String = ""

        txt &= "Position: " & MousePosition().ToString() & vbCrLf

        Dim window_handle As Integer = _
            WindowFromPoint(MousePosition.X, MousePosition.Y)
        txt &= "Window handle: " & window_handle & vbCrLf

        Dim root_handle As Integer = FindRoot(window_handle)
        txt &= "Root handle: " & root_handle & vbCrLf

        txt &= "Root text: " & vbCrLf & WindowText(root_handle) & vbCrLf

        lblInfo.Text = txt
    End Sub

    ' Return the window's root window.
    Private Function FindRoot(ByVal hWnd As Int32) As Int32
        Do
            Dim parent_hwnd As Int32 = GetParent(hWnd)
            If parent_hwnd = 0 Then Return hWnd
            hWnd = parent_hwnd
        Loop
    End Function

    ' Return the window's text.
    Private Function WindowText(ByVal hWnd As Int32) As String
        If hWnd = 0 Then Return ""

        Dim text_len As Integer = GetWindowTextLength(hWnd)
        If text_len = 0 Then Return ""

        Dim sb As New System.Text.StringBuilder(text_len + 1)
        Dim ret = GetWindowText(hWnd, sb, sb.Capacity)
        If ret = 0 Then Return ""

        Return sb.ToString
    End Function
End Class
